From 65fda08eb943e050d24db3a804082ff36202d57e Mon Sep 17 00:00:00 2001
From: 3np <3np@example.com>
Date: Sun, 31 Jul 2022 16:57:18 +0900
Subject: [PATCH 14/21] Add tests

---
 tests/test_browse.py     | 20 ++++++++++++
 tests/test_lookup.py     | 20 ++++++++++++
 tests/test_translator.py | 14 +++++++++
 tests/test_web.py        | 66 +++++++++++++++++++++++++++++++++++++++-
 4 files changed, 119 insertions(+), 1 deletion(-)

diff --git a/tests/test_browse.py b/tests/test_browse.py
index 665adc44..4f6845cd 100644
--- a/tests/test_browse.py
+++ b/tests/test_browse.py
@@ -153,6 +153,26 @@ def test_browse_artist(
     )
 
 
+def test_browse_artist_bad_uri(
+    web_client_mock,
+    web_album_mock_base,
+    web_track_mock,
+    provider,
+    caplog,
+):
+    web_client_mock.get_artist_albums.return_value = [web_album_mock_base]
+    web_client_mock.get_artist_top_tracks.return_value = [
+        web_track_mock,
+        web_track_mock,
+        web_track_mock,
+    ]
+
+    results = provider.browse("spotify:artist:def:xyz")
+
+    assert len(results) == 0
+    assert "Failed to browse" in caplog.text
+
+
 def test_browse_top_tracks_with_too_many_uri_parts(provider):
     results = provider.browse("spotify:top:tracks:foo:bar")
 
diff --git a/tests/test_lookup.py b/tests/test_lookup.py
index 1688f045..da76edfb 100644
--- a/tests/test_lookup.py
+++ b/tests/test_lookup.py
@@ -73,6 +73,15 @@ def test_lookup_of_album_uri(web_client_mock, web_album_mock, provider):
     assert track.album.name == "DEF 456"
 
 
+def test_lookup_of_album_uri_empty_response(web_client_mock, provider, caplog):
+    web_client_mock.get_album.return_value = {}
+
+    results = provider.lookup("spotify:album:def")
+
+    assert len(results) == 0
+    assert "Invalid album response" in caplog.text
+
+
 def test_lookup_of_artist_uri(
     web_track_mock, web_album_mock, web_client_mock, provider
 ):
@@ -157,6 +166,17 @@ def test_lookup_of_playlist_uri(web_client_mock, web_playlist_mock, provider):
     assert track.bitrate == 160
 
 
+def test_lookup_of_playlist_uri_empty_response(
+    web_client_mock, provider, caplog
+):
+    web_client_mock.get_playlist.return_value = None
+
+    results = provider.lookup("spotify:playlist:alice:foo")
+
+    assert len(results) == 0
+    assert "Invalid playlist response" in caplog.text
+
+
 def test_lookup_of_yourtracks_uri(web_client_mock, web_track_mock, provider):
     web_saved_track_mock = {"track": web_track_mock}
     web_client_mock.get_all.return_value = [
diff --git a/tests/test_translator.py b/tests/test_translator.py
index 57203cd2..ec9e8d66 100644
--- a/tests/test_translator.py
+++ b/tests/test_translator.py
@@ -596,6 +596,20 @@ def test_web_to_album_tracks_unplayable(self, web_album_mock):
 
         assert len(tracks) == 0
 
+    def test_web_to_album_tracks_nolist(self, web_album_mock):
+        web_album_mock["tracks"] = {"items": {}}
+
+        tracks = translator.web_to_album_tracks(web_album_mock)
+
+        assert isinstance(tracks, list)
+        assert len(tracks) == 0
+
+    def test_web_to_album_tracks_none(self):
+        tracks = translator.web_to_album_tracks(None)
+
+        assert isinstance(tracks, list)
+        assert len(tracks) == 0
+
 
 class TestWebToTrack:
     def test_calls_web_to_track_ref(self, web_track_mock):
diff --git a/tests/test_web.py b/tests/test_web.py
index 98c4fd54..90f29204 100644
--- a/tests/test_web.py
+++ b/tests/test_web.py
@@ -960,7 +960,7 @@ def test_get_user_playlists(self, spotify_client):
 
     @responses.activate
     def test_with_all_tracks_error(
-        self, spotify_client, foo_album_response, foo_album_next_tracks, caplog
+        self, spotify_client, foo_album_response, caplog
     ):
         responses.add(
             responses.GET,
@@ -1161,6 +1161,16 @@ def test_get_album(self, foo_album, foo_album_next_tracks, spotify_client):
         assert len(responses.calls) == 2
         assert result["tracks"]["items"] == [3, 4, 5, 6, 7, 8]
 
+    @responses.activate
+    def test_get_album_wrong_linktype(self, spotify_client, caplog):
+        link = web.WebLink.from_uri("spotify:album:abba")
+        link.type = "your"
+        results = list(spotify_client.get_album(link))
+
+        assert len(responses.calls) == 0
+        assert len(results) == 0
+        assert "Expecting Spotify album URI" in caplog.text
+
     @responses.activate
     @pytest.mark.parametrize(
         "all_tracks,",
@@ -1245,6 +1255,43 @@ def test_get_artist_albums_error(
         assert results[1] == {}
         assert "Spotify Web API request failed: bar" in caplog.text
 
+    @responses.activate
+    def test_get_artist_albums_wrong_linktype(self, spotify_client, caplog):
+        link = web.WebLink.from_uri("spotify:artist:abba")
+        link.type = "your"
+        results = list(spotify_client.get_artist_albums(link))
+
+        assert len(responses.calls) == 0
+        assert len(results) == 0
+        assert "Expecting Spotify artist URI" in caplog.text
+
+    @responses.activate
+    def test_get_artist_albums_value_error(
+        self, web_album_mock, spotify_client, caplog
+    ):
+        responses.add(
+            responses.GET,
+            url("artists/abba/albums"),
+            json={
+                "href": url("artists/abba/albums"),
+                "items": [{"uri": "BLOPP"}, web_album_mock],
+                "next": None,
+            },
+        )
+        responses.add(
+            responses.GET,
+            url("albums/def"),
+            json=web_album_mock,
+        )
+
+        link = web.WebLink.from_uri("spotify:artist:abba")
+        results = list(spotify_client.get_artist_albums(link))
+
+        assert len(responses.calls) == 2
+        assert len(results) == 1
+        assert results[0]["name"] == "DEF 456"
+        assert "Could not parse 'BLOPP' as a Spotify URI" in caplog.text
+
     @responses.activate
     @pytest.mark.parametrize(
         "uri,success",
@@ -1292,6 +1339,23 @@ def test_get_artist_top_tracks(self, web_track_mock, spotify_client):
         assert len(results) == 2
         assert results[0]["name"] == "ABC 123"
 
+    @responses.activate
+    def test_get_artist_top_tracks_invalid_uri(
+        self, web_track_mock, spotify_client, caplog
+    ):
+        responses.add(
+            responses.GET,
+            url("artists/baz/top-tracks"),
+            json={"tracks": [web_track_mock, web_track_mock]},
+        )
+        link = web.WebLink.from_uri("spotify:artist:baz")
+        link.type = "your"
+        results = spotify_client.get_artist_top_tracks(link)
+
+        assert len(responses.calls) == 0
+        assert len(results) == 0
+        assert "Expecting Spotify artist URI" in caplog.text
+
 
 @pytest.mark.parametrize(
     "uri,type_,id_",

